
package de.ivu.elect.business.ergebnis.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.ergebnis.entity.Ergebnis;

@RequestScoped
@Named(ErgebnisConversationSelect.COMPONENT_NAME)
public class ErgebnisConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "ergebnisConversationSelect";

  @Inject
  protected transient ErgebnisExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(ErgebnisConversationStore.class)
  protected transient ErgebnisConversationStore conversationStore;

  public ErgebnisConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Ergebnis getEntity() {
    return getEntityInternal();
  }

  private Ergebnis getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Ergebnis entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.ergebnis.entity.ErgebnisPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Ergebnis entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.ergebnis.entity.ErgebnisPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.ergebnis.entity.ErgebnisPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Ergebnis attach(Ergebnis entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Ergebnis attach( de.ivu.elect.business.ergebnis.entity.ErgebnisPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
